
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS开发 定位服务与地图 / 憋错料</title>

    <meta name="description" content="iOS开发 定位服务与地图 概览 现在很多社交.电商.团购应用都引入了地图和定位功能,似乎地图功能不再是地图应用和导航应用所特有的.的确,有了地图和定位功能确实让我们的生活更加丰富多彩,极大的改变了我们的生活方式.例如你到了一个陌生的地方想要查找附近的酒店.超市等就可以打开软件搜索周边;类似的,还有很多团购软件可以根据你所在的位置自动为你推荐某些商品.总之,目前地图和定位功能已经大量引入到应用开发中.今天就和大家一起看一下iOS如何进行地图和定位开发. 定位 地图 定位 要实现地图.导航功能,往往需要先熟悉定位功能,在iO">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS开发 定位服务与地图</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>概览</h1>
<p>现在很多社交、电商、团购应用都引入了地图和定位功能，似乎地图功能不再是地图应用和导航应用所特有的。的确，有了地图和定位功能确实让我们的生活更加丰富多彩，极大的改变了我们的生活方式。例如你到了一个陌生的地方想要查找附近的酒店、超市等就可以打开软件搜索周边;类似的，还有很多团购软件可以根据你所在的位置自动为你推荐某些商品。总之，目前地图和定位功能已经大量引入到应用开发中。今天就和大家一起看一下iOS如何进行地图和定位开发。</p>
<ol>
<li><a href="http://www.cnblogs.com/kenshincui/p/4125570.html#location" rel="external nofollow noreferrer">定位</a></li>
<li><a href="http://www.cnblogs.com/kenshincui/p/4125570.html#map" rel="external nofollow noreferrer">地图</a></li>
</ol>
<h1>定位</h1>
<p>要实现地图、导航功能，往往需要先熟悉定位功能，在iOS中通过Core Location框架进行定位操作。Core Location自身可以单独使用，和地图开发框架MapKit完全是独立的，但是往往地图开发要配合定位框架使用。在Core Location中主要包含了定位、地理编码（包括反编码）功能。</p>
<h2>定位功能</h2>
<p>定位是一个很常用的功能，如一些地图软件打开之后如果用户允许软件定位的话，那么打开软件后就会自动锁定到当前位置，如果用户手机移动那么当前位置也会跟随着变化。要实现这个功能需要使用Core Loaction中CLLocationManager类，首先看一下这个类的一些主要方法和属性：</p>
<table>
<tbody>
<tr>
<td>类方法</td>
<td>说明</td>
</tr>
<tr>
<td>+ (BOOL)locationServicesEnabled;</td>
<td>是否启用定位服务，通常如果用户没有启用定位服务可以提示用户打开定位服务</td>
</tr>
<tr>
<td>+ (CLAuthorizationStatus)authorizationStatus;</td>
<td>定位服务授权状态，返回枚举类型：<br />kCLAuthorizationStatusNotDetermined： 用户尚未做出决定是否启用定位服务<br />kCLAuthorizationStatusRestricted： 没有获得用户授权使用定位服务,可能用户没有自己禁止访问授权<br />kCLAuthorizationStatusDenied ：用户已经明确禁止应用使用定位服务或者当前系统定位服务处于关闭状态<br />kCLAuthorizationStatusAuthorizedAlways： 应用获得授权可以一直使用定位服务，即使应用不在使用状态<br />kCLAuthorizationStatusAuthorizedWhenInUse： 使用此应用过程中允许访问定位服务</td>
</tr>
<tr>
<td>属性</td>
<td>说明</td>
</tr>
<tr>
<td>desiredAccuracy</td>
<td>定位精度，枚举类型：</p>
<p>kCLLocationAccuracyBest：最精确定位<br />CLLocationAccuracy kCLLocationAccuracyNearestTenMeters：十米误差范围<br />kCLLocationAccuracyHundredMeters:百米误差范围<br />kCLLocationAccuracyKilometer:千米误差范围<br />kCLLocationAccuracyThreeKilometers:三千米误差范围</p>
</td>
</tr>
<tr>
<td>distanceFilter</td>
<td>位置信息更新最小距离，只有移动大于这个距离才更新位置信息，默认为kCLDistanceFilterNone：不进行距离限制</td>
</tr>
<tr>
<td>对象方法</td>
<td>说明</td>
</tr>
<tr>
<td>startUpdatingLocation</td>
<td>开始定位追踪，开始定位后将按照用户设置的更新频率执行<strong>-(void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray *)locations;</strong>方法反馈定位信息</td>
</tr>
<tr>
<td>stopUpdatingLocation</td>
<td>停止定位追踪</td>
</tr>
<tr>
<td>startUpdatingHeading</td>
<td>开始导航方向追踪</td>
</tr>
<tr>
<td>stopUpdatingHeading</td>
<td>停止导航方向追踪</td>
</tr>
<tr>
<td>startMonitoringForRegion:</td>
<td>开始对某个区域进行定位追踪，开始对某个区域进行定位后。如果用户进入或者走出某个区域会调用<strong>- (void)locationManager:(CLLocationManager *)manager<br />&nbsp;&nbsp;&nbsp; didEnterRegion:(CLRegion *)region</strong>和<strong>- (void)locationManager:(CLLocationManager *)manager<br />&nbsp;&nbsp;&nbsp; didExitRegion:(CLRegion *)region</strong>代理方法反馈相关信息</td>
</tr>
<tr>
<td>stopMonitoringForRegion:</td>
<td>停止对某个区域进行定位追踪</td>
</tr>
<tr>
<td>requestWhenInUseAuthorization</td>
<td>请求获得应用使用时的定位服务授权，注意使用此方法前在要在info.plist中配置<strong>NSLocationWhenInUseUsageDescription</strong></td>
</tr>
<tr>
<td>requestAlwaysAuthorization</td>
<td>请求获得应用一直使用定位服务授权，注意使用此方法前要在info.plist中配置<strong>NSLocationAlwaysUsageDescription</strong></td>
</tr>
<tr>
<td>代理方法</td>
<td>说明</td>
</tr>
<tr>
<td>-(void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray *)locations;</td>
<td>位置发生改变后执行（第一次定位到某个位置之后也会执行）</td>
</tr>
<tr>
<td>- (void)locationManager:(CLLocationManager *)manager<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; didUpdateHeading:(CLHeading *)newHeading;</td>
<td>导航方向发生变化后执行</td>
</tr>
<tr>
<td>&nbsp; - (void)locationManager:(CLLocationManager *)manager<br />&nbsp;&nbsp;&nbsp; didEnterRegion:(CLRegion *)region</td>
<td>进入某个区域之后执行</td>
</tr>
<tr>
<td>- (void)locationManager:(CLLocationManager *)manager<br />&nbsp;&nbsp;&nbsp; didExitRegion:(CLRegion *)region</td>
<td>走出某个区域之后执行</td>
</tr>
</tbody>
</table>
<p>iOS 8 还提供了更加人性化的定位服务选项。App 的定位服务不再仅仅是关闭或打开，现在，定位服务的启用提供了三个选项，「永不」「使用应用程序期间」和「始终」。同时，考虑到能耗问题，如果一款 App 要求始终能在后台开启定位服务，iOS 8 不仅会在首次打开 App 时主动向你询问，还会在日常使用中弹窗提醒你该 App 一直在后台使用定位服务，并询问你是否继续允许。在iOS7及以前的版本，如果在应用程序中使用定位服务只要在程序中调用startUpdatingLocation方法应用就会询问用户是否允许此应用是否允许使用定位服务，同时在提示过程中可以通过在info.plist中配置通过配置<strong>Privacy - Location Usage Description</strong>告诉用户使用的目的，同时这个配置是可选的。<br />但是在iOS8中配置配置项发生了变化，可以通过配置<strong>NSLocationAlwaysUsageDescription</strong>或者<strong>NSLocationWhenInUseUsageDescription</strong>来告诉用户使用定位服务的目的，并且注意这个配置是必须的，如果不进行配置则默认情况下应用无法使用定位服务，打开应用不会给出打开定位服务的提示，除非安装后自己设置此应用的定位服务。同时，在应用程序中需要根据配置对requestAlwaysAuthorization或locationServicesEnabled方法进行请求。由于本人机器已经更新到最新的iOS8.1下面的内容主要针对iOS8，使用iOS7的朋友需要稍作调整。</p>
<pre>//
//  KCMainViewController.m
//  CoreLocation
//
//  Created by Kenshin Cui on 14-03-27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;

@interface KCMainViewController ()&lt;CLLocationManagerDelegate&gt;{

    CLLocationManager *_locationManager;
}

@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    //定位管理器
    _locationManager=[[CLLocationManager alloc]init];

    if (![CLLocationManager locationServicesEnabled]) {
        NSLog(@"定位服务当前可能尚未打开，请设置打开！");
        return;
    }

    //如果没有授权则请求用户授权
    if ([CLLocationManager authorizationStatus]==kCLAuthorizationStatusNotDetermined){
        [_locationManager requestWhenInUseAuthorization];
    }else if([CLLocationManager authorizationStatus]==kCLAuthorizationStatusAuthorizedWhenInUse){
        //设置代理
        _locationManager.delegate=self;
        //设置定位精度
        _locationManager.desiredAccuracy=kCLLocationAccuracyBest;
        //定位频率,每隔多少米定位一次
        CLLocationDistance distance=10.0;//十米定位一次
        _locationManager.distanceFilter=distance;
        //启动跟踪定位
        [_locationManager startUpdatingLocation];
    }
}

#pragma mark - CoreLocation 代理
#pragma mark 跟踪定位代理方法，每次位置发生变化即会执行（只要定位到相应位置）
//可以通过模拟器设置一个虚拟位置，否则在模拟器中无法调用此方法
-(void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray *)locations{
    CLLocation *location=[locations firstObject];//取出第一个位置
    CLLocationCoordinate2D coordinate=location.coordinate;//位置坐标
    NSLog(@"经度：%f,纬度：%f,海拔：%f,航向：%f,行走速度：%f",coordinate.longitude,coordinate.latitude,location.altitude,location.course,location.speed);
    //如果不需要实时定位，使用完即使关闭定位服务
    [_locationManager stopUpdatingLocation];
}

@end</pre>
<p>注意：</p>
<p>1.定位频率和定位精度并不应当越精确越好，需要视实际情况而定，因为越精确越耗性能，也就越费电。</p>
<p>2.定位成功后会根据设置情况频繁调用<strong>-(void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray *)locations</strong>方法，这个方法返回一组地理位置对象数组，每个元素一个CLLocation代表地理位置信息（包含经度、纬度、海报、行走速度等信息），之所以返回数组是因为有些时候一个位置点可能包含多个位置。</p>
<p>3.使用完定位服务后如果不需要实时监控应该立即关闭定位服务以节省资源。</p>
<p>4.除了提供定位功能，CLLocationManager还可以调用startMonitoringForRegion:方法对指定区域进行监控。</p>
<h2>地理编码</h2>
<p>除了提供位置跟踪功能之外，在定位服务中还包含CLGeocoder类用于处理地理编码和逆地理编码（又叫反地理编码）功能。</p>
<p>地理编码：根据给定的位置（通常是地名）确定地理坐标(经、纬度)。</p>
<p>逆地理编码：可以根据地理坐标（经、纬度）确定位置信息（街道、门牌等）。</p>
<p>CLGeocoder最主要的两个方法就是<strong>- (void)geocodeAddressString:(NSString *)addressString completionHandler:(CLGeocodeCompletionHandler)completionHandler;</strong>和<strong>- (void)reverseGeocodeLocation:(CLLocation *)location completionHandler:(CLGeocodeCompletionHandler)completionHandler;，</strong>分别用于地理编码和逆地理编码。下面简单演示一下：</p>
<pre>//
//  KCMainViewController.m
//  CoreLocation
//
//  Created by Kenshin Cui on 14-03-27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;

@interface KCMainViewController ()&lt;CLLocationManagerDelegate&gt;{

    CLGeocoder *_geocoder;
}

@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    _geocoder=[[CLGeocoder alloc]init];
    [self getCoordinateByAddress:@"北京"];
    [self getAddressByLatitude:39.54 longitude:116.28];
}

#pragma mark 根据地名确定地理坐标
-(void)getCoordinateByAddress:(NSString *)address{
    //地理编码
    [_geocoder geocodeAddressString:address completionHandler:^(NSArray *placemarks, NSError *error) {
        //取得第一个地标，地标中存储了详细的地址信息，注意：一个地名可能搜索出多个地址
        CLPlacemark *placemark=[placemarks firstObject];

        CLLocation *location=placemark.location;//位置
        CLRegion *region=placemark.region;//区域
        NSDictionary *addressDic= placemark.addressDictionary;//详细地址信息字典,包含以下部分信息
//        NSString *name=placemark.name;//地名
//        NSString *thoroughfare=placemark.thoroughfare;//街道
//        NSString *subThoroughfare=placemark.subThoroughfare; //街道相关信息，例如门牌等
//        NSString *locality=placemark.locality; // 城市
//        NSString *subLocality=placemark.subLocality; // 城市相关信息，例如标志性建筑
//        NSString *administrativeArea=placemark.administrativeArea; // 州
//        NSString *subAdministrativeArea=placemark.subAdministrativeArea; //其他行政区域信息
//        NSString *postalCode=placemark.postalCode; //邮编
//        NSString *ISOcountryCode=placemark.ISOcountryCode; //国家编码
//        NSString *country=placemark.country; //国家
//        NSString *inlandWater=placemark.inlandWater; //水源、湖泊
//        NSString *ocean=placemark.ocean; // 海洋
//        NSArray *areasOfInterest=placemark.areasOfInterest; //关联的或利益相关的地标
        NSLog(@"位置:%@,区域:%@,详细信息:%@",location,region,addressDic);
    }];
}

#pragma mark 根据坐标取得地名
-(void)getAddressByLatitude:(CLLocationDegrees)latitude longitude:(CLLocationDegrees)longitude{
    //反地理编码
    CLLocation *location=[[CLLocation alloc]initWithLatitude:latitude longitude:longitude];
    [_geocoder reverseGeocodeLocation:location completionHandler:^(NSArray *placemarks, NSError *error) {
        CLPlacemark *placemark=[placemarks firstObject];
        NSLog(@"详细信息:%@",placemark.addressDictionary);
    }];
}

@end</pre>
<h1>地图</h1>
<p>iOS从6.0开始地图数据不再由谷歌驱动，而是改用自家地图，当然在国内它的数据是由高德地图提供的。这样一来，如果在iOS6.0之前进行地图开发的话使用方法会有所不同，基于目前的情况其实使用iOS6.0之前版本的系统基本已经寥寥无几了，所有在接下来的内容中不会再针对iOS5及之前版本的地图开发进行介绍。</p>
<p>在iOS中进行地图开发主要有两种方式，一种是直接利用MapKit框架进行地图开发，利用这种方式可以对地图进行精准的控制；另一种方式是直接调用苹果官方自带的地图应用，主要用于一些简单的地图应用（例如：进行导航覆盖物填充等），无法进行精确的控制。当然，本节重点内容还是前者，后面的内容也会稍加提示。</p>
<p>用MapKit之前需要简单了解一下MapKit中地图展示控件MKMapView的的一些常用属性和方法，具体如下表：</p>
<table>
<tbody>
<tr>
<td>属性</td>
<td>说明</td>
</tr>
<tr>
<td>userTrackingMode</td>
<td>跟踪类型，是一个枚举：<br />MKUserTrackingModeNone :不进行用户位置跟踪；<br />MKUserTrackingModeFollow :跟踪用户位置；<br />MKUserTrackingModeFollowWithHeading :跟踪用户位置并且跟踪用户前进方向；</td>
</tr>
<tr>
<td>mapType</td>
<td>地图类型，是一个枚举：<br />MKMapTypeStandard :标准地图，一般情况下使用此地图即可满足；<br />MKMapTypeSatellite ：卫星地图；<br />MKMapTypeHybrid ：混合地图，加载最慢比较消耗资源；</td>
</tr>
<tr>
<td>userLocation</td>
<td>用户位置，只读属性</td>
</tr>
<tr>
<td>annotations</td>
<td>当前地图中的所有大头针，只读属性</td>
</tr>
<tr>
<td>对象方法</td>
<td>说明</td>
</tr>
<tr>
<td>- (void)addAnnotation:(id &lt;MKAnnotation&gt;)annotation;</td>
<td>添加大头针，对应的有添加大头针数组</td>
</tr>
<tr>
<td>- (void)removeAnnotation:(id &lt;MKAnnotation&gt;)annotation;</td>
<td>删除大头针，对应的有删除大头针数组</td>
</tr>
<tr>
<td>
<br />- (void)setRegion:(MKCoordinateRegion)region animated:(BOOL)animated;</p>
</td>
<td>设置地图显示区域，用于控制当前屏幕显示地图范围</td>
</tr>
<tr>
<td>- (void)setCenterCoordinate:(CLLocationCoordinate2D)coordinate animated:(BOOL)animated;</td>
<td>设置地图中心点位置</td>
</tr>
<tr>
<td>- (CGPoint)convertCoordinate:(CLLocationCoordinate2D)coordinate toPointToView:(UIView *)view;</td>
<td>将地理坐标（经纬度）转化为数学坐标（UIKit坐标）</td>
</tr>
<tr>
<td>- (CLLocationCoordinate2D)convertPoint:(CGPoint)point toCoordinateFromView:(UIView *)view;</td>
<td>将数学坐标转换为地理坐标</td>
</tr>
<tr>
<td>- (MKAnnotationView *)dequeueReusableAnnotationViewWithIdentifier:(NSString *)identifier;</td>
<td>从缓存池中取出大头针，类似于UITableView中取出UITableViewCell，为了进行性能优化而设计</td>
</tr>
<tr>
<td>- (void)selectAnnotation:(id &lt;MKAnnotation&gt;)annotation animated:(BOOL)animated;</td>
<td>选中指定的大头针</td>
</tr>
<tr>
<td>- (void)deselectAnnotation:(id &lt;MKAnnotation&gt;)annotation animated:(BOOL)animated;</td>
<td>取消选中指定的大头针</td>
</tr>
<tr>
<td>代理方法</td>
<td>说明</td>
</tr>
<tr>
<td>- (void)mapView:(MKMapView *)mapView didUpdateUserLocation:(MKUserLocation *)userLocation ;</td>
<td>用户位置发生改变时触发（第一次定位到用户位置也会触发该方法）</td>
</tr>
<tr>
<td>- (void)mapView:(MKMapView *)mapView didUpdateUserLocation:(MKUserLocation *)userLocation ;</td>
<td>显示区域发生改变后触发</td>
</tr>
<tr>
<td>- (void)mapViewDidFinishLoadingMap:(MKMapView *)mapView;</td>
<td>地图加载完成后触发</td>
</tr>
<tr>
<td>- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id &lt;MKAnnotation&gt;)annotation;</td>
<td>显示大头针时触发，返回大头针视图，通常自定义大头针可以通过此方法进行</td>
</tr>
<tr>
<td>- (void)mapView:(MKMapView *)mapView didSelectAnnotationView:(MKAnnotationView *)view&nbsp;</td>
<td>点击选中某个大头针时触发</td>
</tr>
<tr>
<td>- (void)mapView:(MKMapView *)mapView didDeselectAnnotationView:(MKAnnotationView *)view</td>
<td>取消选中大头针时触发</td>
</tr>
<tr>
<td>- (MKOverlayRenderer *)mapView:(MKMapView *)mapView rendererForOverlay:(id &lt;MKOverlay&gt;)overlay</td>
<td>渲染地图覆盖物时触发</td>
</tr>
</tbody>
</table>
<h2>用户位置跟踪</h2>
<p>在很多带有地图的应用中默认打开地图都会显示用户当前位置，同时将当前位置标记出来放到屏幕中点方便用户对周围情况进行查看。如果在iOS6或者iOS7中实现这个功能只需要添加地图控件、设置用户跟踪模式、在<strong>-(void)mapView:(MKMapView *)mapView didUpdateUserLocation:(MKUserLocation *)userLocation</strong>代理方法中设置地图中心区域及显示范围。但是在iOS8中用法稍有不同：</p>
<p>1.由于在地图中进行用户位置跟踪需要使用定位功能，而定位功能在iOS8中设计发生了变化，因此必须按照前面定位章节中提到的内容进行配置和请求。</p>
<p>2.iOS8中不需要进行中心点的指定，默认会将当前位置设置中心点并自动设置显示区域范围。</p>
<p>了解以上两点，要进行用户位置跟踪其实就相当简单了，值得一提的是<strong>-(void)mapView:(MKMapView *)mapView didUpdateUserLocation:(MKUserLocation *)userLocation</strong>这个代理方法。这个方法只有在定位（利用前面章节中的定位内容）到当前位置之后就会调用，以后每当用户位置发生改变就会触发，调用频率相当频繁。</p>
<h2>大头针</h2>
<p>在iOS开发中经常会标记某个位置，需要使用地图标注，也就是大家俗称的&ldquo;大头针&rdquo;。只要一个NSObject类实现MKAnnotation协议就可以作为一个大头针，通常会重写协议中<strong>coordinate</strong>（标记位置）、<strong>title</strong>（标题）、<strong>subtitle</strong>（子标题）三个属性，然后在程序中创建大头针对象并调用<strong>addAnnotation:</strong>方法添加大头针即可（之所以iOS没有定义一个基类实现这个协议供开发者使用，多数原因应该是MKAnnotation是一个模型对象，对于多数应用模型会稍有不同，例如后面的内容中会给大头针模型对象添加其他属性）。</p>
<p>KCAnnotation.h</p>
<pre>//
//  KCAnnotation.h
//  MapKit
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import &lt;Foundation/Foundation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCAnnotation : NSObject&lt;MKAnnotation&gt;

@property (nonatomic) CLLocationCoordinate2D coordinate;
@property (nonatomic, copy) NSString *title;
@property (nonatomic, copy) NSString *subtitle;

@end</pre>
<p>KCMainViewController.m</p>
<pre>//
//  KCMainViewController.m
//  MapKit Annotation
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//  37.785834   -122.406417
//  39.92 116.39

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;
#import "KCAnnotation.h"

@interface KCMainViewController ()&lt;MKMapViewDelegate&gt;{
    CLLocationManager *_locationManager;
    MKMapView *_mapView;
}

@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    [self initGUI];
}

#pragma mark 添加地图控件
-(void)initGUI{
    CGRect rect=[UIScreen mainScreen].bounds;
    _mapView=[[MKMapView alloc]initWithFrame:rect];
    [self.view addSubview:_mapView];
    //设置代理
    _mapView.delegate=self;

    //请求定位服务
    _locationManager=[[CLLocationManager alloc]init];
    if(![CLLocationManager locationServicesEnabled]||[CLLocationManager authorizationStatus]!=kCLAuthorizationStatusAuthorizedWhenInUse){
        [_locationManager requestWhenInUseAuthorization];
    }

    //用户位置追踪(用户位置追踪用于标记用户当前位置，此时会调用定位服务)
    _mapView.userTrackingMode=MKUserTrackingModeFollow;

    //设置地图类型
    _mapView.mapType=MKMapTypeStandard;

    //添加大头针
    [self addAnnotation];
}

#pragma mark 添加大头针
-(void)addAnnotation{
    CLLocationCoordinate2D location1=CLLocationCoordinate2DMake(39.95, 116.35);
    KCAnnotation *annotation1=[[KCAnnotation alloc]init];
    [email&#160;protected]"CMJ Studio";
    [email&#160;protected]"Kenshin Cui‘s Studios";
    annotation1.coordinate=location1;
    [_mapView addAnnotation:annotation1];

    CLLocationCoordinate2D location2=CLLocationCoordinate2DMake(39.87, 116.35);
    KCAnnotation *annotation2=[[KCAnnotation alloc]init];
    [email&#160;protected]"Kenshin&amp;Kaoru";
    [email&#160;protected]"Kenshin Cui‘s Home";
    annotation2.coordinate=location2;
    [_mapView addAnnotation:annotation2];
}

#pragma mark - 地图控件代理方法
#pragma mark 更新用户位置，只要用户改变则调用此方法（包括第一次定位到用户位置）
-(void)mapView:(MKMapView *)mapView didUpdateUserLocation:(MKUserLocation *)userLocation{

    NSLog(@"%@",userLocation);
    //设置地图显示范围(如果不进行区域设置会自动显示区域范围并指定当前用户位置为地图中心点)
    //    MKCoordinateSpan span=MKCoordinateSpanMake(0.01, 0.01);
    //    MKCoordinateRegion region=MKCoordinateRegionMake(userLocation.location.coordinate, span);
    //    [_mapView setRegion:region animated:true];
}

@end</pre>
<p>运行效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NDQwMTY4NDY4OTIucG5n.jpg" /></p>
<h3>设置大头针视图</h3>
<p>在一些应用中系统默认的大头针样式可能无法满足实际的需求，此时就需要修改大头针视图默认样式。根据前面MapKit的代理方法不难发现<strong>- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id &lt;MKAnnotation&gt;)annotation;</strong>方法可以返回一个大头针视图，只要实现这个方法并在这个方法中定义一个大头针视图MKAnnotationView对象并设置相关属性就可以改变默认大头针的样式。MKAnnotationView常用属性：</p>
<table>
<tbody>
<tr>
<td>属性</td>
<td>说明</td>
</tr>
<tr>
<td>annotation</td>
<td>大头针模型信息，包括标题、子标题、地理位置。</td>
</tr>
<tr>
<td>image</td>
<td>大头针图片</td>
</tr>
<tr>
<td>canShowCallout</td>
<td>点击大头针是否显示标题、子标题内容等，注意如果在<strong>- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id &lt;MKAnnotation&gt;)annotation;</strong>方法中重新定义大头针默认情况是无法交互的需要设置为true。</td>
</tr>
<tr>
<td>calloutOffset</td>
<td>点击大头针时弹出详情信息视图的偏移量</td>
</tr>
<tr>
<td>selected</td>
<td>是否被选中状态</td>
</tr>
<tr>
<td>leftCalloutAccessoryView</td>
<td>弹出详情左侧视图</td>
</tr>
<tr>
<td>rightCalloutAccessoryView</td>
<td>弹出详情右侧视图</td>
</tr>
</tbody>
</table>
<p>需要注意：</p>
<p>a.这个代理方法的调用时机:每当有大头针显示到系统可视界面中时就会调用此方法返回一个大头针视图放到界面中，同时当前系统位置标注（也就是地图中蓝色的位置点）也是一个大头针，也会调用此方法，因此处理大头针视图时需要区别对待。</p>
<p>b.类似于UITableView的代理方法，此方法调用频繁，开发过程中需要重复利用MapKit的缓存池将大头针视图缓存起来重复利用。</p>
<p>c.自定义大头针默认情况下不允许交互，如果交互需要设置canShowCallout=true</p>
<p>d.如果代理方法返回nil则会使用默认大头针视图，需要根据情况设置。</p>
<p>下面以一个示例进行大头针视图设置，这里设置了大头针的图片、弹出视图、偏移量等信息。</p>
<p>KCAnnotation.h</p>
<pre>//
//  KCAnnotation.h
//  MapKit
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import &lt;Foundation/Foundation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCAnnotation : NSObject&lt;MKAnnotation&gt;

@property (nonatomic) CLLocationCoordinate2D coordinate;
@property (nonatomic, copy) NSString *title;
@property (nonatomic, copy) NSString *subtitle;

#pragma mark 自定义一个图片属性在创建大头针视图时使用
@property (nonatomic,strong) UIImage *image;

@end</pre>
<p>KCMainViewController.m</p>
<pre>//
//  KCMainViewController.m
//  MapKit Annotation
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//  37.785834   -122.406417
//  39.92 116.39

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;
#import "KCAnnotation.h"

@interface KCMainViewController ()&lt;MKMapViewDelegate&gt;{
    CLLocationManager *_locationManager;
    MKMapView *_mapView;
}

@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    [self initGUI];
}

#pragma mark 添加地图控件
-(void)initGUI{
    CGRect rect=[UIScreen mainScreen].bounds;
    _mapView=[[MKMapView alloc]initWithFrame:rect];
    [self.view addSubview:_mapView];
    //设置代理
    _mapView.delegate=self;

    //请求定位服务
    _locationManager=[[CLLocationManager alloc]init];
    if(![CLLocationManager locationServicesEnabled]||[CLLocationManager authorizationStatus]!=kCLAuthorizationStatusAuthorizedWhenInUse){
        [_locationManager requestWhenInUseAuthorization];
    }

    //用户位置追踪(用户位置追踪用于标记用户当前位置，此时会调用定位服务)
    _mapView.userTrackingMode=MKUserTrackingModeFollow;

    //设置地图类型
    _mapView.mapType=MKMapTypeStandard;

    //添加大头针
    [self addAnnotation];
}

#pragma mark 添加大头针
-(void)addAnnotation{
    CLLocationCoordinate2D location1=CLLocationCoordinate2DMake(39.95, 116.35);
    KCAnnotation *annotation1=[[KCAnnotation alloc]init];
    [email&#160;protected]"CMJ Studio";
    [email&#160;protected]"Kenshin Cui‘s Studios";
    annotation1.coordinate=location1;
    annotation1.image=[UIImage imageNamed:@"icon_pin_floating.png"];
    [_mapView addAnnotation:annotation1];

    CLLocationCoordinate2D location2=CLLocationCoordinate2DMake(39.87, 116.35);
    KCAnnotation *annotation2=[[KCAnnotation alloc]init];
    [email&#160;protected]"Kenshin&amp;Kaoru";
    [email&#160;protected]"Kenshin Cui‘s Home";
    annotation2.coordinate=location2;
    annotation2.image=[UIImage imageNamed:@"icon_paopao_waterdrop_streetscape.png"];
    [_mapView addAnnotation:annotation2];
}

#pragma mark - 地图控件代理方法
#pragma mark 显示大头针时调用，注意方法中的annotation参数是即将显示的大头针对象
-(MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id&lt;MKAnnotation&gt;)annotation{
    //由于当前位置的标注也是一个大头针，所以此时需要判断，此代理方法返回nil使用默认大头针视图
    if ([annotation isKindOfClass:[KCAnnotation class]]) {
        static NSString *[email&#160;protected]"AnnotationKey1";
        MKAnnotationView *annotationView=[_mapView dequeueReusableAnnotationViewWithIdentifier:key1];
        //如果缓存池中不存在则新建
        if (!annotationView) {
            annotationView=[[MKAnnotationView alloc]initWithAnnotation:annotation reuseIdentifier:key1];
            annotationView.canShowCallout=true;//允许交互点击
            annotationView.calloutOffset=CGPointMake(0, 1);//定义详情视图偏移量
            annotationView.leftCalloutAccessoryView=[[UIImageView alloc]initWithImage:[UIImage imageNamed:@"icon_classify_cafe.png"]];//定义详情左侧视图
        }

        //修改大头针视图
        //重新设置此类大头针视图的大头针模型(因为有可能是从缓存池中取出来的，位置是放到缓存池时的位置)
        annotationView.annotation=annotation;
        annotationView.image=((KCAnnotation *)annotation).image;//设置大头针视图的图片

        return annotationView;
    }else {
        return nil;
    }
}
@end</pre>
<p>运行效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NDk0MzI0NjM2MDkuanBn.jpg" /></p>
<blockquote><p>注意：</p>
<p>在MapKit框架中除了MKAnnotationView之外还有一个MKPinAnnotationView，它是MKAnnotationView的子类，相比MKAnnotationView多了两个属性pinColor和animationDrop，分别用于设置大头针视图颜色和添加大头针动画。</p></blockquote>
<h2>扩展--自定义大头针弹详情视图</h2>
<p>通过上面的示例不难看出MKAnnotationView足够强大（何况还有MKPinAnnotationView），很多信息都可以进行设置，但是唯独不能修改大头针描述详情视图（仅仅支持详情中左右视图内容）。要实现这个需求目前开发中普遍采用的思路就是:</p>
<p>a.点击一个大头针A时重新在A的坐标处添加另一个大头针B（注意此时将A对应的大头针视图canShowCallout设置为false）作为大头针详情模型，然后在<strong>- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id &lt;MKAnnotation&gt;)annotation;</strong>代理方法中判断大头针类型，如果是B则重写MKAnnotationView（可以自定义一个类C继承于MKAnnotationView），返回自定义大头针视图C。</p>
<p>b.定义大头针视图C继承于MKAnnotationView（或者MKPinAnnotationView）,在自定义大头针视图中添加自己的控件，完成自定义布局。</p>
<p>在使用百度地图客户端时当点击一个搜索位置时可以看到此位置的评价等信息，视图效果大概如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NDk0NzA1OTM2NzkuanBn.jpg" /></p>
<p>下面不妨试着实现一下这个效果：</p>
<p>大头针模型：KCAnnotation.h</p>
<pre>//
//  KCAnnotation.h
//  MapKit
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import &lt;Foundation/Foundation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCAnnotation : NSObject&lt;MKAnnotation&gt;

@property (nonatomic) CLLocationCoordinate2D coordinate;
@property (nonatomic, copy) NSString *title;
@property (nonatomic, copy) NSString *subtitle;

#pragma mark 自定义一个图片属性在创建大头针视图时使用
@property (nonatomic,strong) UIImage *image;

#pragma mark 大头针详情左侧图标
@property (nonatomic,strong) UIImage *icon;
#pragma mark 大头针详情描述
@property (nonatomic,copy) NSString *detail;
#pragma mark 大头针右下方星级评价
@property (nonatomic,strong) UIImage *rate;

@end</pre>
<p>弹出详情大头针模型：KCCalloutAnnotation.h</p>
<pre>//
//  KCCalloutAnnotation.h
//  MapKit
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import &lt;UIKit/UIKit.h&gt;
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCCalloutAnnotation : NSObject&lt;MKAnnotation&gt;

@property (nonatomic) CLLocationCoordinate2D coordinate;
@property (nonatomic, copy,readonly) NSString *title;
@property (nonatomic, copy,readonly) NSString *subtitle;

#pragma mark 左侧图标
@property (nonatomic,strong) UIImage *icon;
#pragma mark 详情描述
@property (nonatomic,copy) NSString *detail;
#pragma mark 星级评价
@property (nonatomic,strong) UIImage *rate;

@end</pre>
<p>弹出详情大头针视图：KCCalloutAnnotatonView.h</p>
<pre>//
//  KCCalloutView.h
//  MapKit
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//  自定义弹出标注视图

#import &lt;UIKit/UIKit.h&gt;
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;
#import "KCCalloutAnnotation.h"

@interface KCCalloutAnnotationView : MKAnnotationView

@property (nonatomic ,strong) KCCalloutAnnotation *annotation;

#pragma mark 从缓存取出标注视图
+(instancetype)calloutViewWithMapView:(MKMapView *)mapView;

@end</pre>
<p>KCCalloutAnnotationView.m</p>
<pre>//
//  KCCalloutView.m
//  MapKit
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import "KCCalloutAnnotationView.h"
#define kSpacing 5
#define kDetailFontSize 12
#define kViewOffset 80

@interface KCCalloutAnnotationView(){
    UIView *_backgroundView;
    UIImageView *_iconView;
    UILabel *_detailLabel;
    UIImageView *_rateView;
}

@end

@implementation KCCalloutAnnotationView

-(instancetype)init{
    if(self=[super init]){
        [self layoutUI];
    }
    return self;
}
-(instancetype)initWithFrame:(CGRect)frame{
    if (self=[super initWithFrame:frame]) {
        [self layoutUI];
    }
    return self;
}

-(void)layoutUI{
    //背景
    _backgroundView=[[UIView alloc]init];
    _backgroundView.backgroundColor=[UIColor whiteColor];
    //左侧添加图标
    _iconView=[[UIImageView alloc]init];

    //上方详情
    _detailLabel=[[UILabel alloc]init];
    _detailLabel.lineBreakMode=NSLineBreakByWordWrapping;
    //[_text sizeToFit];
    _detailLabel.font=[UIFont systemFontOfSize:kDetailFontSize];

    //下方星级
    _rateView=[[UIImageView alloc]init];

    [self addSubview:_backgroundView];
    [self addSubview:_iconView];
    [self addSubview:_detailLabel];
    [self addSubview:_rateView];
}

+(instancetype)calloutViewWithMapView:(MKMapView *)mapView{
    static NSString *[email&#160;protected]"calloutKey1";
    KCCalloutAnnotationView *calloutView=(KCCalloutAnnotationView *)[mapView dequeueReusableAnnotationViewWithIdentifier:calloutKey];
    if (!calloutView) {
        calloutView=[[KCCalloutAnnotationView alloc]init];
    }
    return calloutView;
}

#pragma mark 当给大头针视图设置大头针模型时可以在此处根据模型设置视图内容
-(void)setAnnotation:(KCCalloutAnnotation *)annotation{
    [super setAnnotation:annotation];
    //根据模型调整布局
    _iconView.image=annotation.icon;
    _iconView.frame=CGRectMake(kSpacing, kSpacing, annotation.icon.size.width, annotation.icon.size.height);

    _detailLabel.text=annotation.detail;
    float detailWidth=150.0;
    CGSize detailSize= [annotation.detail boundingRectWithSize:CGSizeMake(detailWidth, MAXFLOAT) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName: [UIFont systemFontOfSize:kDetailFontSize]} context:nil].size;
    float detailX=CGRectGetMaxX(_iconView.frame)+kSpacing;
    _detailLabel.frame=CGRectMake(detailX, kSpacing, detailSize.width, detailSize.height);
    _rateView.image=annotation.rate;
    _rateView.frame=CGRectMake(detailX, CGRectGetMaxY(_detailLabel.frame)+kSpacing, annotation.rate.size.width, annotation.rate.size.height);

    float backgroundWidth=CGRectGetMaxX(_detailLabel.frame)+kSpacing;
    float backgroundHeight=_iconView.frame.size.height+2*kSpacing;
    _backgroundView.frame=CGRectMake(0, 0, backgroundWidth, backgroundHeight);
    self.bounds=CGRectMake(0, 0, backgroundWidth, backgroundHeight+kViewOffset);

}
@end</pre>
<p>主视图控制器：KCMainViewController.m</p>
<pre>//
//  KCMainViewController.m
//  MapKit Annotation
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//  37.785834   -122.406417
//  39.92 116.39

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;
#import "KCAnnotation.h"
#import "KCCalloutAnnotationView.h"
#import "KCCalloutAnnotationView.h"

@interface KCMainViewController ()&lt;MKMapViewDelegate&gt;{
    CLLocationManager *_locationManager;
    MKMapView *_mapView;
}

@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    [self initGUI];
}

#pragma mark 添加地图控件
-(void)initGUI{
    CGRect rect=[UIScreen mainScreen].bounds;
    _mapView=[[MKMapView alloc]initWithFrame:rect];
    [self.view addSubview:_mapView];
    //设置代理
    _mapView.delegate=self;

    //请求定位服务
    _locationManager=[[CLLocationManager alloc]init];
    if(![CLLocationManager locationServicesEnabled]||[CLLocationManager authorizationStatus]!=kCLAuthorizationStatusAuthorizedWhenInUse){
        [_locationManager requestWhenInUseAuthorization];
    }

    //用户位置追踪(用户位置追踪用于标记用户当前位置，此时会调用定位服务)
    _mapView.userTrackingMode=MKUserTrackingModeFollow;

    //设置地图类型
    _mapView.mapType=MKMapTypeStandard;

    //添加大头针
    [self addAnnotation];
}

#pragma mark 添加大头针
-(void)addAnnotation{
    CLLocationCoordinate2D location1=CLLocationCoordinate2DMake(39.95, 116.35);
    KCAnnotation *annotation1=[[KCAnnotation alloc]init];
    [email&#160;protected]"CMJ Studio";
    [email&#160;protected]"Kenshin Cui‘s Studios";
    annotation1.coordinate=location1;
    annotation1.image=[UIImage imageNamed:@"icon_pin_floating.png"];
    annotation1.icon=[UIImage imageNamed:@"icon_mark1.png"];
    [email&#160;protected]"CMJ Studio...";
    annotation1.rate=[UIImage imageNamed:@"icon_Movie_Star_rating.png"];
    [_mapView addAnnotation:annotation1];

    CLLocationCoordinate2D location2=CLLocationCoordinate2DMake(39.87, 116.35);
    KCAnnotation *annotation2=[[KCAnnotation alloc]init];
    [email&#160;protected]"Kenshin&amp;Kaoru";
    [email&#160;protected]"Kenshin Cui‘s Home";
    annotation2.coordinate=location2;
    annotation2.image=[UIImage imageNamed:@"icon_paopao_waterdrop_streetscape.png"];
    annotation2.icon=[UIImage imageNamed:@"icon_mark2.png"];
    [email&#160;protected]"Kenshin Cui...";
    annotation2.rate=[UIImage imageNamed:@"icon_Movie_Star_rating.png"];
    [_mapView addAnnotation:annotation2];
}

#pragma mark - 地图控件代理方法
#pragma mark 显示大头针时调用，注意方法中的annotation参数是即将显示的大头针对象
-(MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id&lt;MKAnnotation&gt;)annotation{
    //由于当前位置的标注也是一个大头针，所以此时需要判断，此代理方法返回nil使用默认大头针视图
    if ([annotation isKindOfClass:[KCAnnotation class]]) {
        static NSString *[email&#160;protected]"AnnotationKey1";
        MKAnnotationView *annotationView=[_mapView dequeueReusableAnnotationViewWithIdentifier:key1];
        //如果缓存池中不存在则新建
        if (!annotationView) {
            annotationView=[[MKAnnotationView alloc]initWithAnnotation:annotation reuseIdentifier:key1];
//            annotationView.canShowCallout=true;//允许交互点击
            annotationView.calloutOffset=CGPointMake(0, 1);//定义详情视图偏移量
            annotationView.leftCalloutAccessoryView=[[UIImageView alloc]initWithImage:[UIImage imageNamed:@"icon_classify_cafe.png"]];//定义详情左侧视图
        }

        //修改大头针视图
        //重新设置此类大头针视图的大头针模型(因为有可能是从缓存池中取出来的，位置是放到缓存池时的位置)
        annotationView.annotation=annotation;
        annotationView.image=((KCAnnotation *)annotation).image;//设置大头针视图的图片

        return annotationView;
    }else if([annotation isKindOfClass:[KCCalloutAnnotation class]]){
        //对于作为弹出详情视图的自定义大头针视图无弹出交互功能（canShowCallout=false，这是默认值），在其中可以自由添加其他视图（因为它本身继承于UIView）
        KCCalloutAnnotationView *calloutView=[KCCalloutAnnotationView calloutViewWithMapView:mapView];
        calloutView.annotation=annotation;
        return calloutView;
    } else {
        return nil;
    }
}

#pragma mark 选中大头针时触发
//点击一般的大头针KCAnnotation时添加一个大头针作为所点大头针的弹出详情视图
-(void)mapView:(MKMapView *)mapView didSelectAnnotationView:(MKAnnotationView *)view{
    KCAnnotation *annotation=view.annotation;
    if ([view.annotation isKindOfClass:[KCAnnotation class]]) {
        //点击一个大头针时移除其他弹出详情视图
//        [self removeCustomAnnotation];
        //添加详情大头针，渲染此大头针视图时将此模型对象赋值给自定义大头针视图完成自动布局
        KCCalloutAnnotation *annotation1=[[KCCalloutAnnotation alloc]init];
        annotation1.icon=annotation.icon;
        annotation1.detail=annotation.detail;
        annotation1.rate=annotation.rate;
        annotation1.coordinate=view.annotation.coordinate;
        [mapView addAnnotation:annotation1];
    }
}

#pragma mark 取消选中时触发
-(void)mapView:(MKMapView *)mapView didDeselectAnnotationView:(MKAnnotationView *)view{
    [self removeCustomAnnotation];
}

#pragma mark 移除所用自定义大头针
-(void)removeCustomAnnotation{
    [_mapView.annotations enumerateObjectsUsingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
        if ([obj isKindOfClass:[KCCalloutAnnotation class]]) {
            [_mapView removeAnnotation:obj];
        }
    }];
}
@end&nbsp;</pre>
<p>在这个过程中需要注意几点：</p>
<p>1.大头针A作为一个普通大头针，其中最好保存自定义大头针视图C所需要的模型以便根据不同的模型初始化视图。</p>
<p>2.自定义大头针视图C的大头针模型B中不需要title、subtitle属性，最好设置为只读；模型中最后保存自定义大头针视图C所需要的布局模型数据。</p>
<p>3.只有点击非B类大头针时才新增自定义大头针，并且增加时要首先移除其他B类大头针避免重叠（一般建议放到取消大头针选择的代理方法中）。</p>
<p>4.通常在自定义大头针视图C设置大头针模型时布局界面，此时需要注意新增大头针的位置，通常需要偏移一定的距离才能达到理想的效果。</p>
<p>运行效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NTA0MjIxNTI2OTQuZ2lm.jpg" /></p>
<h2>使用自带的地图应用</h2>
<p>除了可以使用MapKit框架进行地图开发，对地图有精确的控制和自定义之外，如果对于应用没有特殊要求的话选用苹果自带的地图应用也是一个不错的选择。使用苹果自带的应用时需要用到MapKit中的MKMapItem类，这个类有一个<strong>openInMapsWithLaunchOptions:</strong>动态方法和一个<strong>openMapsWithItems: launchOptions:</strong>静态方法用于打开苹果地图应用。第一个方法用于在地图上标注一个位置，第二个方法除了可以标注多个位置外还可以进行多个位置之间的驾驶导航，使用起来也是相当方便。在熟悉这两个方法使用之前有必要对两个方法中的options参数做一下简单说明：</p>
<table>
<tbody>
<tr>
<td>键(常量)</td>
<td>说明</td>
<td>值</td>
</tr>
<tr>
<td>MKLaunchOptionsDirectionsModeKey</td>
<td>路线模式，常量</td>
<td>MKLaunchOptionsDirectionsModeDriving&nbsp; 驾车模式<br />MKLaunchOptionsDirectionsModeWalking 步行模式</td>
</tr>
<tr>
<td>MKLaunchOptionsMapTypeKey</td>
<td>地图类型，枚举</td>
<td>MKMapTypeStandard ：标准模式<br />MKMapTypeSatellite ：卫星模式<br />MKMapTypeHybrid&nbsp; ：混合模式</td>
</tr>
<tr>
<td>MKLaunchOptionsMapCenterKey</td>
<td>中心点坐标，CLLocationCoordinate2D类型</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>MKLaunchOptionsMapSpanKey</td>
<td>地图显示跨度，MKCoordinateSpan 类型</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>MKLaunchOptionsShowsTrafficKey</td>
<td>是否 显示交通状况，布尔型</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>MKLaunchOptionsCameraKey</td>
<td>3D地图效果，MKMapCamera类型<br />注意：此属性从iOS7及以后可用，前面的属性从iOS6开始可用</td>
<td>&nbsp;</td>
</tr>
</tbody>
</table>
<h3>单个位置的标注</h3>
<p>下面的代码演示了如何在苹果自带地图应用上标记一个位置，首先根据反地理编码获得一个CLPlacemark位置对象，然后将其转换为MKPlacemark对象用于MKMapItem初始化，最后调用其<strong>openInMapsWithLaunchOptions:</strong>打开地图应用并标记：</p>
<pre>//
//  KCMainViewController.m
//  AppleMap
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCMainViewController ()
@property (nonatomic,strong) CLGeocoder *geocoder;
@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    _geocoder=[[CLGeocoder alloc]init];

    [self location];
}

#pragma mark 在地图上定位
-(void)location{
    //根据&ldquo;北京市&rdquo;进行地理编码
    [_geocoder geocodeAddressString:@"北京市" completionHandler:^(NSArray *placemarks, NSError *error) {
        CLPlacemark *clPlacemark=[placemarks firstObject];//获取第一个地标
        MKPlacemark *mkplacemark=[[MKPlacemark alloc]initWithPlacemark:clPlacemark];//定位地标转化为地图的地标
        NSDictionary *[email&#160;protected]{MKLaunchOptionsMapTypeKey:@(MKMapTypeStandard)};
        MKMapItem *mapItem=[[MKMapItem alloc]initWithPlacemark:mkplacemark];
        [mapItem openInMapsWithLaunchOptions:options];
    }];
}
@end</pre>
<p>运行效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NTA1MTEyMTkxNzIuanBn.jpg" /></p>
<h3>标记多个位置</h3>
<p>如果要标记多个位置需要调用MKMapItem的静态方法，下面的代码演示中需要注意，使用CLGeocoder进行定位时一次只能定位到一个位置，所以第二个位置定位放到了第一个位置获取成功之后。</p>
<pre>//
//  KCMainViewController.m
//  AppleMap
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCMainViewController ()
@property (nonatomic,strong) CLGeocoder *geocoder;
@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    _geocoder=[[CLGeocoder alloc]init];

    [self listPlacemark];
}

-(void)listPlacemark{
    //根据&ldquo;北京市&rdquo;进行地理编码
    [_geocoder geocodeAddressString:@"北京市" completionHandler:^(NSArray *placemarks, NSError *error) {
        CLPlacemark *clPlacemark1=[placemarks firstObject];//获取第一个地标
        MKPlacemark *mkPlacemark1=[[MKPlacemark alloc]initWithPlacemark:clPlacemark1];
        //注意地理编码一次只能定位到一个位置，不能同时定位，所在放到第一个位置定位完成回调函数中再次定位
        [_geocoder geocodeAddressString:@"郑州市" completionHandler:^(NSArray *placemarks, NSError *error) {
            CLPlacemark *clPlacemark2=[placemarks firstObject];//获取第一个地标
            MKPlacemark *mkPlacemark2=[[MKPlacemark alloc]initWithPlacemark:clPlacemark2];
            NSDictionary *[email&#160;protected]{MKLaunchOptionsMapTypeKey:@(MKMapTypeStandard)};
            //MKMapItem *mapItem1=[MKMapItem mapItemForCurrentLocation];//当前位置
            MKMapItem *mapItem1=[[MKMapItem alloc]initWithPlacemark:mkPlacemark1];
            MKMapItem *mapItem2=[[MKMapItem alloc]initWithPlacemark:mkPlacemark2];
            [MKMapItem openMapsWithItems:@[mapItem1,mapItem2] launchOptions:options];

        }];

    }];
}
@end</pre>
<p>运行效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NTExNTM3MTc0OTcuZ2lm.jpg" /></p>
<h3>地图导航</h3>
<p>要使用地图导航功能在自带地图应用中相当简单，只要设置参数配置导航模式即可，例如在上面代码基础上设置驾驶模式，则地图应用会启动驾驶模式计算两点之间的距离同时对路线进行规划。</p>
<pre>//
//  KCMainViewController.m
//  AppleMap
//
//  Created by Kenshin Cui on 14/3/27.
//  Copyright (c) 2014年 Kenshin Cui. All rights reserved.
//

#import "KCMainViewController.h"
#import &lt;CoreLocation/CoreLocation.h&gt;
#import &lt;MapKit/MapKit.h&gt;

@interface KCMainViewController ()
@property (nonatomic,strong) CLGeocoder *geocoder;
@end

@implementation KCMainViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    _geocoder=[[CLGeocoder alloc]init];

    [self turnByTurn];
}

-(void)turnByTurn{
    //根据&ldquo;北京市&rdquo;地理编码
    [_geocoder geocodeAddressString:@"北京市" completionHandler:^(NSArray *placemarks, NSError *error) {
        CLPlacemark *clPlacemark1=[placemarks firstObject];//获取第一个地标
        MKPlacemark *mkPlacemark1=[[MKPlacemark alloc]initWithPlacemark:clPlacemark1];
        //注意地理编码一次只能定位到一个位置，不能同时定位，所在放到第一个位置定位完成回调函数中再次定位
        [_geocoder geocodeAddressString:@"郑州市" completionHandler:^(NSArray *placemarks, NSError *error) {
            CLPlacemark *clPlacemark2=[placemarks firstObject];//获取第一个地标
            MKPlacemark *mkPlacemark2=[[MKPlacemark alloc]initWithPlacemark:clPlacemark2];
            NSDictionary *[email&#160;protected]{MKLaunchOptionsMapTypeKey:@(MKMapTypeStandard),MKLaunchOptionsDirectionsModeKey:MKLaunchOptionsDirectionsModeDriving};
            //MKMapItem *mapItem1=[MKMapItem mapItemForCurrentLocation];//当前位置
            MKMapItem *mapItem1=[[MKMapItem alloc]initWithPlacemark:mkPlacemark1];
            MKMapItem *mapItem2=[[MKMapItem alloc]initWithPlacemark:mkPlacemark2];
            [MKMapItem openMapsWithItems:@[mapItem1,mapItem2] launchOptions:options];

        }];

    }];
}
@end</pre>
<p>运行效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzYyMDQ2LzIwMTQxMS8yNzA4NTEyMzkxODkwMTkuanBn.jpg" /></p>
<blockquote><p>注意：其实如果不用苹果自带的地图应用也可以实现地图导航，MapKit中提供了MKDirectionRequest对象用于计算路线，提供了MKDirections用于计算方向，这样一来只需要调用MKMapView的addOverlay等方法添加覆盖物即可实现类似的效果，有兴趣的朋友可以试一下。</p></blockquote>
<p>由于定位和地图框架中用到了诸多类，有些初学者容易混淆，下面简单对比一下。</p>
<p>CLLocation：用于表示位置信息，包含地理坐标、海拔等信息，包含在CoreLoaction框架中。</p>
<p>MKUserLocation：一个特殊的大头针，表示用户当前位置。</p>
<p>CLPlacemark：定位框架中地标类，封装了详细的地理信息。</p>
<p>MKPlacemark：类似于CLPlacemark，只是它在MapKit框架中，可以根据CLPlacemark创建MKPlacemark。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-23 13:06:44 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS开发 定位服务与地图的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyNmXj0.html" rel="bookmark">iOS开发-定位服务和地理围栏</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.获得用户的位置使用CoreLocation框架.1.如果你的应用基于位置来正确运行,你应该在你的Info.plist中包括UIRequiredDeviceCapabilities键.App Store使用这个信息来阻止没有定位的设备下载该应用.UIRequiredDeviceCapabilities键对应一个字符串数组,包括:1)location-services字符串--如果你请求一般的定位服务2)gps--如果你请求GPS级的精度如果你的应用需要定位,但是没有定位也能正常运行,就不要包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyDLWL4.html" rel="bookmark">iOS开发-定位服务iOS8&period;0以上授权</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				if ([UIDevice currentDevice].systemVersion.doubleValue &gt; 8.0) { [self.locMgr requestAlwaysAuthorization]; } else { [self.locMgr startUpdatingLocation]; } - (void)locationManager:(CLLocationManager *)manager didChangeAuthorizationStatus:(CLAuthorizati			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmGELY3.html" rel="bookmark">iOS定位服务与地图开发&lpar;1&rpar;---获取经纬度</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				定位服务是通过GPS等方式查找定位自己的位置的,再通过地图标注出来. 在iOS中定位服务和地图开发是使用两套API分别完成的. 1.定位服务: iOS系统提供3种不同定位途径: 1&gt;WiFi定位:通过查询一个WiFi路由器的地理位置信息,iPhone.iPod Touch.iPad都可以采用. 2&gt;蜂窝式移动电话基站定位:通过移动运营商基站定位 3&gt;GPS卫星定位:通过3~4颗GPS卫星位置定位,最为准确,但是耗电量大 iOS不像Android系统在定位服务编程时可以指定采用哪种途径进行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG8JDo0.html" rel="bookmark">iOS定位服务与地图开发&lpar;4&rpar;---显示地图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS 6之前,苹果使用的是谷歌地图,iOS 6之后,苹果使用了自己的地图(国内好像用的是高德地图),但是API编程接口与iOS 5相比没有太大变化. iOS 应用程序中使用Map Kit API开发地图应用程序,使用MKMapView类作为地图显示视图,其委托协议是MKMapViewDelegate. 1.显示地图: .h文件中代码 #import &lt;MapKit/MapKit.h&gt; @interface YXCViewController &lt;MKMapViewDelegate&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35wVVnM.html" rel="bookmark">iOS定位服务与地图开发&lpar;3&rpar;---地理信息编码查询</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				即根据一个NSString的文字描述对象获取相关的地理坐标. 采用CLGeocoder类操作,具体方法: 1&gt;geocodeAddressDictionary:completionHandler: 通过指定一个地址信息字典对象参数进行查询 2&gt;geocodeAddressString:completionHandler:通过指定一个地址信息字符串参数进行查询 3&gt;geocodeAddressString:inRegion:completionHandler:通过制定地址信息字符串和查询范			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0konnd0.html" rel="bookmark">iOS定位服务与地图开发&lpar;2&rpar;---地理信息反编码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上节我们通过定位获取了经度和纬度数值,但是一般人很难看懂这些数字. 地理信息反编码:就是根据这些经纬数字返回地点的相关文字描述信息,这些文字描述信息被封装在CLPlacemark类中,我们称这个类为&quot;地标&quot;类. 地理信息反编码使用CLGeocoder类实现,这个类能够实现在地理坐标与地理文字描述信息之间的转换. CLGeocoder类中进行地理信息反编码的方法是:reverseGeocodeLocation: completionHandler: location:是要定位的地理位置对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQJYB3.html" rel="bookmark">IOS开发笔记－百度地图&lpar;第三方库&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近做了百度地图,在导入SDK后遇到了一些问题 编译错误: linker command failed with exit code 1 (use -v to see invocation) 想了很多办法,查了很多资料,最后终于解决. 可能原因: 1. 有重复的.m文件,或者未导入 解决办法:有重复的删除即可 在工作左边导航栏Target--&gt;Build Phases--&gt;compile Sources中,第三库库的所有.m文件都添加到里面 2.Valid Architectures 的值 在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rajLl0.html" rel="bookmark">iOS 开发指南 第16章 定位服务与地图应用之使用苹果地图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 显示地图 MKMapView MKMapViewDelegate 准备:加载MapKit.framework 设置地图样式 代理-实现代理方法 - (void)viewDidLoad { [super viewDidLoad]; 设置样式,枚举类型MKMapType self.mapView.mapType = MKMapTypeStandard; // self.mapView.mapType = MKMapTypeSatellite; 将当前视图控制器赋值给地图视图的delegate属性			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXlpXaM.html" rel="bookmark">iOS 开发指南 第16章 定位服务与地图应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 定位服务编码 使用Core Location框架 CLLocationManger:用于定位服务管理类,能够给我们提供位置信息和高度信息,也可以监控设备进入或离开某个区域,还可以获得设备的运行方向等. CLLocation:封装了位置和高度信息. CLLocationMangerDelegate 准备:加载Core Location框架 修改工程配置:Supporting Files-Info.pist添加NSLocationAlwaysUSageDescription和NSLocation			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oa7goM.html" rel="bookmark" class="title">第 8 章  函数</a>
					<div>
						在本章中,我们将学习编写函数.函数是带名字的代码块,用于完成具体的工作. 要执行函数定义的特定任务,可调用函数.需要在程序中多次执行同一项任务时,我们无需反复编写完成该任务的代码,而只需调用执行该任务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvYQ80.html" rel="bookmark" class="title">mysql1主多从配置</a>
					<div>
						mysql一主多从的配置: 其实1主多从的配置与一主一从配置非常相似,现在主要讲讲一主多从的大概配置方法. 一, 1,master端开启binlog日志,并且设置server id=1. 2.重启服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGNJv4.html" rel="bookmark" class="title">随机数大揭秘</a>
					<div>
						参考文章:杨中科老师的&lt;随机数是骗人的,.Net.Java.C为我作证&gt; http://www.cnblogs.com/rupeng/p/3723018.html#!comments 1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDdjv8M.html" rel="bookmark" class="title">json学习总结</a>
					<div>
						关于JSON,一种字符串,JS中接触过一点,但没怎么用过,这次在做教务系统时,在U层传值时,要经常用到json,那么,它跟普通的string有什么区别呢? JSON:轻量级的数据交换格式,主要用于与服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x5gbr3.html" rel="bookmark" class="title">安卓界面设计中属性设置</a>
					<div>
						最近在学习安卓界面设计的时候,对于其中很多参数很是迷茫,于是查找了一番之后总结如下: 第一组: android:gravity: view组件内部内容的gravity属性 android:layout ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkZ294.html" rel="bookmark" class="title">JavaScript中的&ast;top、&ast;left、&ast;width、&ast;Height详解</a>
					<div>
						来源:http://www.ido321.com/911.html html代码 1: &lt;body&gt; 2: &lt;div class=&quot;father&quot; id=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1P6l4.html" rel="bookmark" class="title">https大势已来？看腾讯专家如何在高并发压测中支持https</a>
					<div>
						WeTest 导读 用epoll编写一个高并发网络程序是很常见的任务,但在epoll中加入ssl层的支持则是一个不常见的场景.腾讯WeTest服务器压力测产品,在用户反馈中收到了不少支持https协议 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OD7OG4.html" rel="bookmark" class="title">android UI&amp;&num;160&semi;适配小节</a>
					<div>
						一.   像素密度表 像素密度表 比如UE 给了三张切图分别对应: mdpi,     xhdpi,     xxdpi 10 * 10,     20 * 20,     30 * 30 上面的值都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qEbA53.html" rel="bookmark" class="title">linux解压多个文件</a>
					<div>
						方法很多种, 根据实际文件类型,位置情况进行变通: 1. for查询:for tar in *.tar.gz; do tar xvf $tar; done2. 列出文件列表,然后xargs 逐一解压: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmojyD3.html" rel="bookmark" class="title">编写shell管理脚本（二）</a>
					<div>
						8.1  先测试“/etc/vsftpd”.“/etc/hosts”是否为目录,并通过“$?”变量查看返回状态值,据此判断测试结果.[[email protected] ~]# [ -d /etc/v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWDNQb0.html" rel="bookmark" class="title">&lbrack;课&rsqb;13&period;3 Oracle加密表空间进行数据加密的示例</a>
					<div>
						接上篇:http://www.cnblogs.com/myrunning/p/4292049.html 1查看数据库版本 2查看当前数据库表空间 从这里看到我们此时数据库里没有加密表空间. 3创建加密 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35w1jjM.html" rel="bookmark" class="title">bootstrap-面板中嵌套列表组</a>
					<div>
						1.运行效果如图所示 2.实现代码如下 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt;     &lt;meta charset=&quot;utf-8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xazpD3.html" rel="bookmark" class="title">循环-05&period; 兔子繁衍问题&lpar;15&rpar;</a>
					<div>
						1 #include&lt;iostream&gt; 2 using namespace std; 3 int sum(int n){ 4 if(n==1||n==2) 5 return 1; 6 e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqrE24.html" rel="bookmark" class="title">【转】Cocos2d  -  观察者模式NotificationCenter</a>
					<div>
						http://shahdza.blog.51cto.com/2410787/1611575 [唠叨] 观察者模式 也叫订阅/发布(Subscribe/Publish)模式,是 MVC( 模型-视图-控 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QaGzN4.html" rel="bookmark" class="title">ACM-ICPC国际大学生程序设计竞赛北京赛区&lpar;2015&rpar;网络赛</a>
					<div>
						#1235 : New Teaching Buildings 时间限制:2000ms 单点时限:2000ms 内存限制:256MB 描述 Thanks to the generous finance  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YQO5O0.html" rel="bookmark" class="title">mysql5&period;7中的sys表详解（转）</a>
					<div>
						在说明系统数据库之前,先来看下MySQL在数据字典方面的演变历史:MySQL4.1 提供了information_schema 数据字典.从此可以很简单的用SQL语句来检索需要的系统元数据了.MySQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rjd7v0.html" rel="bookmark" class="title">百度地图出错 java&period;lang&period;NoClassDefFoundError</a>
					<div>
						java.lang.NoClassDefFoundError: com.baidu.mapapi.BMapManager解决办法 用百度地图,可能把工程复制了些位置吧 出错了 解决办法: 一.右击项目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQJ6VM.html" rel="bookmark" class="title">iOS枚举的运用</a>
					<div>
						1.什么是枚举? 枚举其实就是一个整型常数的集合,最简单的例子就是表示星期的SUN, MON, TUE, WED, THU, FRI,SAT, 就是一个枚举. 2.iOS中枚举的使用 在ObjC中可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGoGw4.html" rel="bookmark" class="title">流氓 2345&period;com的新动态及解决方法</a>
					<div>
						安装了[电脑公司]的Win7_SP1之后, IE的主页被绑架. 症状是先转到 IE959.com,然后自动跳转到 www.2345.com 网上当然有很多例子了,可是都没有效果. 1. 更改IE设置没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35pYz20.html" rel="bookmark" class="title">&lbrack;转载&rsqb;阿狸说 我喜欢香蕉，可是你给了我一车苹果，然后你被自己感动了</a>
					<div>
						阿狸说: 1 我喜欢香蕉,可是你给了我一车苹果,然后你说你被自己感动了,问我为什么不感动.我无言以对,然后你告诉全世界,你花光了所有的钱给我买了一车苹果,可是我却没有一点点感动,我一定是一个铁石心肠的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
